
unit kyft100;
interface

uses
  StrUtils, 
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, Libc, QTypes, QExtCtrls, QComCtrls, QActnList, QButtons, QMask,
  QMenus, IniFiles;

type
  TMain = class(TForm)
    Timer_UpdateTimer: TTimer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar: TStatusBar;
    Help1: TMenuItem;
    About1: TMenuItem;
    PageControl1: TPageControl;
    TabVFO: TTabSheet;
    GroupBox7: TGroupBox;
    btn_kp7: TButton;
    btn_kp8: TButton;
    btn_kp9: TButton;
    btn_kp4: TButton;
    btn_kp5: TButton;
    btn_kp6: TButton;
    btn_kp1: TButton;
    btn_kp2: TButton;
    btn_kp3: TButton;
    btn_kp0: TButton;
    btn_kpgo: TButton;
    btn_kpup: TButton;
    btn_kpdown: TButton;
    LCD_Freq: TLCDNumber;
    LCD_SetFreq: TLCDNumber;
    btn_kp_Clr: TButton;
    btn_kp_Bksp: TButton;
    btn_kp_dot: TButton;
    GroupBox9: TGroupBox;
    cb_Auto_Update: TCheckBox;
    msk_edit_update: TMaskEdit;
    Label9: TLabel;
    GroupBox2: TGroupBox;
    RB_VFO_A: TRadioButton;
    RB_VFO_B: TRadioButton;
    cb_Split: TCheckBox;
    GroupBox6: TGroupBox;
    rb_1K: TRadioButton;
    rb_5K: TRadioButton;
    rb_9K: TRadioButton;
    rb_10K: TRadioButton;
    rb_12p5K: TRadioButton;
    rb_20K: TRadioButton;
    rb_25K: TRadioButton;
    rb_50K: TRadioButton;
    rb_100K: TRadioButton;
    rb_Custom: TRadioButton;
    txt_Freq_Step: TEdit;
    rb_1M: TRadioButton;
    rb_10M: TRadioButton;
    GroupBox1: TGroupBox;
    RB_USB: TRadioButton;
    RB_AM: TRadioButton;
    RB_DIG: TRadioButton;
    RB_WFM: TRadioButton;
    RB_CW: TRadioButton;
    RB_CWR: TRadioButton;
    RB_FM: TRadioButton;
    RB_LSB: TRadioButton;
    GroupBox3: TGroupBox;
    rb_Filter_24k: TRadioButton;
    rb_Filter_6K: TRadioButton;
    rb_Filter_300: TRadioButton;
    rb_Filter_500: TRadioButton;
    GroupBox12: TGroupBox;
    LB_CTCSS: TListBox;
    LB_DCS: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox5: TGroupBox;
    cb_Tone_On: TCheckBox;
    rb_Tone_Encode: TRadioButton;
    rb_Tone_TSQ: TRadioButton;
    rb_Tone_DCS: TRadioButton;
    GroupBox4: TGroupBox;
    RB_Repeat_SPLX: TRadioButton;
    RB_Repeat_Minus: TRadioButton;
    RB_Repeat_Plus: TRadioButton;
    TabMemory: TTabSheet;
    grp_Memory: TGroupBox;
    lb_Memory: TListBox;
    Label3: TLabel;
    edit_Mem_Desc: TEdit;
    Label8: TLabel;
    edit_Mem_Command: TEdit;
    GroupBox11: TGroupBox;
    btn_Open_Mem: TButton;
    btn_Clear: TButton;
    btn_Add: TButton;
    btn_Mem_Delete: TButton;
    btn_Replace_Entry: TButton;
    btn_Save: TButton;
    btn_Mem_Up: TButton;
    btn_Mem_Dn: TButton;
    btn_Test: TButton;
    btn_Get: TButton;
    TabStatus: TTabSheet;
    GroupBox10: TGroupBox;
    lbl_split: TLabel;
    lbl_cat_in: TLabel;
    lbl_power: TLabel;
    lbl_mute: TLabel;
    lbl_tx_in: TLabel;
    lbl_srch: TLabel;
    GroupBox8: TGroupBox;
    pb_Fwd_Tx: TProgressBar;
    pb_Rev_Tx: TProgressBar;
    pb_S_Units: TProgressBar;
    pb_Mic_Level: TProgressBar;
    pb_Final_Temp: TProgressBar;
    pb_ALC_Level: TProgressBar;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    LCD_vswr: TLCDNumber;
    Label12: TLabel;
    TabBand: TTabSheet;
    Grp_HamBands: TGroupBox;
    rb_H160m: TRadioButton;
    rb_S120m: TRadioButton;
    rb_S90m: TRadioButton;
    rb_H80m: TRadioButton;
    rb_S60m: TRadioButton;
    rb_S49m: TRadioButton;
    rb_S41m: TRadioButton;
    rb_H40m: TRadioButton;
    rb_S31m: TRadioButton;
    rb_H30m: TRadioButton;
    rb_S25m: TRadioButton;
    rb_S22m: TRadioButton;
    rb_H20m: TRadioButton;
    rb_S19m: TRadioButton;
    rb_H17m: TRadioButton;
    rb_S16m: TRadioButton;
    rb_H15m: TRadioButton;
    rb_S13m: TRadioButton;
    rb_H12m: TRadioButton;
    rb_S11m: TRadioButton;
    rb_H10m: TRadioButton;
    rb_H6m: TRadioButton;
    rb_H2m: TRadioButton;
    rb_H70cm: TRadioButton;
    rb_AM_Bcast: TRadioButton;
    rb_FM_Bcast: TRadioButton;
    GroupBox13: TGroupBox;
    rb_wwv5: TRadioButton;
    rb_wwv15: TRadioButton;
    rb_wwv10: TRadioButton;
    rb_CHU330: TRadioButton;
    rb_chu7335: TRadioButton;
    TabLaunch: TTabSheet;
    GroupBox14: TGroupBox;
    rb_cb01: TRadioButton;
    rb_cb02: TRadioButton;
    rb_cb03: TRadioButton;
    rb_cb39: TRadioButton;
    rb_cb23: TRadioButton;
    rb_cb12: TRadioButton;
    rb_cb22: TRadioButton;
    rb_cb11: TRadioButton;
    rb_cb21: TRadioButton;
    rb_cb33: TRadioButton;
    rb_cb32: TRadioButton;
    rb_cb31: TRadioButton;
    rb_cb25: TRadioButton;
    rb_cb24: TRadioButton;
    rb_cb40: TRadioButton;
    rb_cb38: TRadioButton;
    rb_cb37: TRadioButton;
    rb_cb36: TRadioButton;
    rb_cb35: TRadioButton;
    rb_cb34: TRadioButton;
    rb_cb13: TRadioButton;
    rb_cb29: TRadioButton;
    rb_cb28: TRadioButton;
    rb_cb27: TRadioButton;
    rb_cb26: TRadioButton;
    rb_cb04: TRadioButton;
    rb_cb16: TRadioButton;
    rb_cb15: TRadioButton;
    rb_cb14: TRadioButton;
    rb_cb30: TRadioButton;
    rb_cb07: TRadioButton;
    rb_cb06: TRadioButton;
    rb_cb05: TRadioButton;
    rb_cb17: TRadioButton;
    rb_cb20: TRadioButton;
    rb_cb19: TRadioButton;
    rb_cb18: TRadioButton;
    rb_cb10: TRadioButton;
    rb_cb09: TRadioButton;
    rb_cb08: TRadioButton;
    Timer_Scan: TTimer;
    GroupBox15: TGroupBox;
    cb_Scan: TCheckBox;
    msk_ScanDelay: TMaskEdit;
    Label14: TLabel;
    Timer_ScanVFO: TTimer;
    GroupBox16: TGroupBox;
    rb_ScanVFO_Up: TRadioButton;
    rb_ScanVFO_Dn: TRadioButton;
    cb_ScanVFO: TCheckBox;
    msk_edit_ScanVFO_delay: TMaskEdit;
    Label15: TLabel;
    Bevel1: TBevel;
    Button1: TButton;
    btn_Tune: TButton;
    Label16: TLabel;
    Label17: TLabel;
    msk_PauseDelay: TMaskEdit;
    Label18: TLabel;
    Timer_Pause: TTimer;
    msk_VFOPauseDelay: TMaskEdit;
    Label19: TLabel;
    Timer_VFOPauseDelay: TTimer;
    GroupBox17: TGroupBox;
    btn_MemUp: TButton;
    btn_MemDown: TButton;
    Label13: TLabel;
    btn_Launch1: TButton;
    btn_Launch2: TButton;
    btn_Launch3: TButton;
    btn_Launch4: TButton;
    btn_Launch5: TButton;
    btn_Launch6: TButton;
    btn_Launch7: TButton;
    btn_Launch8: TButton;
    btn_Launch9: TButton;
    btn_Launch10: TButton;
    btn_Launch11: TButton;
    btn_Launch12: TButton;
    btn_UpdateNow: TButton;
    procedure RB_LSBClick(Sender: TObject);
    procedure RB_USBClick(Sender: TObject);
    procedure RB_AMClick(Sender: TObject);
    procedure RB_DIGClick(Sender: TObject);
    procedure RB_FMClick(Sender: TObject);
    procedure RB_WFMClick(Sender: TObject);
    procedure RB_CWClick(Sender: TObject);
    procedure RB_CWRClick(Sender: TObject);
    procedure LB_CTCSSClick(Sender: TObject);
    procedure LB_DCSClick(Sender: TObject);
    procedure RB_VFO_AClick(Sender: TObject);
    procedure RB_VFO_BClick(Sender: TObject);
    procedure RB_Split_OnxClick(Sender: TObject);
    procedure RB_Split_OffxClick(Sender: TObject);
    procedure RB_Repeat_SplxClick(Sender: TObject);
    procedure RB_Repeat_PlusClick(Sender: TObject);
    procedure RB_Repeat_MinusClick(Sender: TObject);
    procedure RB_Tone_OffClick(Sender: TObject);
    procedure RB_Tone_ENCClick(Sender: TObject);
    procedure RB_Tone_DECClick(Sender: TObject);
    procedure RB_Tone_DCSClick(Sender: TObject);
    procedure btn_Set_FreqClick(Sender: TObject);
    procedure btn_QuitClick(Sender: TObject);
    procedure btn_Freq_PlusClick(Sender: TObject);
    procedure btn_Freq_MinusClick(Sender: TObject);
    procedure rb_CustomClick(Sender: TObject);
    procedure rb_1KClick(Sender: TObject);
    procedure rb_5KClick(Sender: TObject);
    procedure rb_9KClick(Sender: TObject);
    procedure rb_10KClick(Sender: TObject);
    procedure rb_12p5KClick(Sender: TObject);
    procedure rb_20KClick(Sender: TObject);
    procedure rb_25KClick(Sender: TObject);
    procedure rb_50KClick(Sender: TObject);
    procedure rb_100KClick(Sender: TObject);
    procedure rb_1MClick(Sender: TObject);
    procedure rb_10MClick(Sender: TObject);
    procedure Timer_UpdateTimerTimer(Sender: TObject);
    procedure btn_kpdownClick(Sender: TObject);
    procedure btn_kpupClick(Sender: TObject);
    procedure btn_kpgoClick(Sender: TObject);
    procedure cb_Tone_OnClick(Sender: TObject);
    procedure rb_Tone_EncodeClick(Sender: TObject);
    procedure rb_Tone_TSQClick(Sender: TObject);
    procedure rb_filter_24kxClick(Sender: TObject);
    procedure rb_filter_6kxClick(Sender: TObject);
    procedure rb_Filter_300xClick(Sender: TObject);
    procedure rb_Filter_500xClick(Sender: TObject);
    procedure cb_SplitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rb_Filter_24kClick(Sender: TObject);
    procedure rb_Filter_6KClick(Sender: TObject);
    procedure rb_Filter_300Click(Sender: TObject);
    procedure rb_Filter_500Click(Sender: TObject);
    procedure btn_Open_MemClick(Sender: TObject);
    procedure lb_MemoryDblClick(Sender: TObject);
    procedure btn_ClearClick(Sender: TObject);
    procedure lb_MemoryClick(Sender: TObject);
    procedure btn_Replace_EntryClick(Sender: TObject);
    procedure btn_TestClick(Sender: TObject);
    procedure btn_AddClick(Sender: TObject);
    procedure btn_SaveClick(Sender: TObject);
    procedure btn_Mem_UpClick(Sender: TObject);
    procedure btn_Mem_DnClick(Sender: TObject);
    procedure btn_kp_ClrClick(Sender: TObject);
    procedure btn_kp0Click(Sender: TObject);
    procedure btn_kp1Click(Sender: TObject);
    procedure btn_kp2Click(Sender: TObject);
    procedure btn_kp3Click(Sender: TObject);
    procedure btn_kp4Click(Sender: TObject);
    procedure btn_kp5Click(Sender: TObject);
    procedure btn_kp6Click(Sender: TObject);
    procedure btn_kp7Click(Sender: TObject);
    procedure btn_kp8Click(Sender: TObject);
    procedure btn_kp9Click(Sender: TObject);
    procedure btn_kp_BkspClick(Sender: TObject);
    procedure btn_kp_dotClick(Sender: TObject);
    procedure btn_Mem_DeleteClick(Sender: TObject);
    procedure btn_GetClick(Sender: TObject);
    procedure cb_Auto_UpdateClick(Sender: TObject);
    procedure msk_edit_updateChange(Sender: TObject);
    procedure btn_TuneClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure rb_H160mClick(Sender: TObject);
    procedure rb_H80mClick(Sender: TObject);
    procedure rb_H40mClick(Sender: TObject);
    procedure rb_H30mClick(Sender: TObject);
    procedure rb_H20mClick(Sender: TObject);
    procedure rb_H17mClick(Sender: TObject);
    procedure rb_H15mClick(Sender: TObject);
    procedure rb_H12mClick(Sender: TObject);
    procedure rb_H10mClick(Sender: TObject);
    procedure rb_H6mClick(Sender: TObject);
    procedure rb_H2mClick(Sender: TObject);
    procedure rb_H70cmClick(Sender: TObject);
    procedure rb_S120mClick(Sender: TObject);
    procedure rb_S90mClick(Sender: TObject);
    procedure rb_S60mClick(Sender: TObject);
    procedure rb_S49mClick(Sender: TObject);
    procedure rb_S41mClick(Sender: TObject);
    procedure rb_S31mClick(Sender: TObject);
    procedure rb_S25mClick(Sender: TObject);
    procedure rb_S22mClick(Sender: TObject);
    procedure rb_S19mClick(Sender: TObject);
    procedure rb_S16mClick(Sender: TObject);
    procedure rb_S13mClick(Sender: TObject);
    procedure rb_S11mClick(Sender: TObject);
    procedure rb_FM_BcastClick(Sender: TObject);
    procedure rb_AM_BcastClick(Sender: TObject);
    procedure rb_wwv5Click(Sender: TObject);
    procedure rb_wwv10Click(Sender: TObject);
    procedure rb_wwv15Click(Sender: TObject);
    procedure rb_CHU330Click(Sender: TObject);
    procedure rb_chu7335Click(Sender: TObject);
    procedure rb_cb08Click(Sender: TObject);
    procedure rb_cb12Click(Sender: TObject);
    procedure rb_cb13Click(Sender: TObject);
    procedure rb_cb17Click(Sender: TObject);
    procedure rb_cb23Click(Sender: TObject);
    procedure rb_cb01Click(Sender: TObject);
    procedure rb_cb02Click(Sender: TObject);
    procedure rb_cb03Click(Sender: TObject);
    procedure rb_cb04Click(Sender: TObject);
    procedure rb_cb05Click(Sender: TObject);
    procedure rb_cb06Click(Sender: TObject);
    procedure rb_cb07Click(Sender: TObject);
    procedure rb_cb09Click(Sender: TObject);
    procedure rb_cb10Click(Sender: TObject);
    procedure rb_cb11Click(Sender: TObject);
    procedure rb_cb14Click(Sender: TObject);
    procedure rb_cb15Click(Sender: TObject);
    procedure rb_cb16Click(Sender: TObject);
    procedure rb_cb18Click(Sender: TObject);
    procedure rb_cb19Click(Sender: TObject);
    procedure rb_cb20Click(Sender: TObject);
    procedure rb_cb21Click(Sender: TObject);
    procedure rb_cb22Click(Sender: TObject);
    procedure rb_cb24Click(Sender: TObject);
    procedure rb_cb25Click(Sender: TObject);
    procedure rb_cb26Click(Sender: TObject);
    procedure rb_cb27Click(Sender: TObject);
    procedure rb_cb28Click(Sender: TObject);
    procedure rb_cb29Click(Sender: TObject);
    procedure rb_cb30Click(Sender: TObject);
    procedure rb_cb31Click(Sender: TObject);
    procedure rb_cb32Click(Sender: TObject);
    procedure rb_cb33Click(Sender: TObject);
    procedure rb_cb34Click(Sender: TObject);
    procedure rb_cb35Click(Sender: TObject);
    procedure rb_cb36Click(Sender: TObject);
    procedure rb_cb37Click(Sender: TObject);
    procedure rb_cb38Click(Sender: TObject);
    procedure rb_cb39Click(Sender: TObject);
    procedure rb_cb40Click(Sender: TObject);
    procedure cb_ScanClick(Sender: TObject);
    procedure Timer_ScanTimer(Sender: TObject);
    procedure msk_VFOPauseDelayChange(Sender: TObject);
    procedure cb_ScanVFOClick(Sender: TObject);
    procedure Timer_ScanVFOTimer(Sender: TObject);
    procedure msk_edit_ScanVFO_delayChange(Sender: TObject);
    procedure Timer_PauseTimer(Sender: TObject);
    procedure Timer_VFOPauseDelayTimer(Sender: TObject);
    procedure btn_MemUpClick(Sender: TObject);
    procedure btn_MemDownClick(Sender: TObject);
    procedure btn_Launch1Click(Sender: TObject);
    procedure btn_Launch2Click(Sender: TObject);
    procedure btn_Launch3Click(Sender: TObject);
    procedure btn_Launch4Click(Sender: TObject);
    procedure btn_Launch5Click(Sender: TObject);
    procedure btn_Launch6Click(Sender: TObject);
    procedure btn_Launch7Click(Sender: TObject);
    procedure btn_Launch8Click(Sender: TObject);
    procedure btn_Launch9Click(Sender: TObject);
    procedure btn_Launch10Click(Sender: TObject);
    procedure btn_Launch11Click(Sender: TObject);
    procedure btn_Launch12Click(Sender: TObject);
    procedure btn_UpdateNowClick(Sender: TObject);

    // misc procedures not generated by kylix
    procedure UpdateNow(Sender: TObject);
    procedure System_Send_Cmdstring(cmdstring:PChar; Err_Msg:string; error_id:integer);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;
  MemEntries: integer;
  CurrScan: integer;
  MemTable: array[0..2500] of string;
  Memory_Max_Entries : integer;
  PTT, MemUpdated :Boolean;
  Old_Mode: char;
  ScanSigDetect: Boolean;
  HomeDirectory: string;
  kyFT100IniFile: TIniFile;
  ft100_device: string;
  ft100_error_count: integer;
  error_id:integer;
implementation

{$R *.xfm}
 {$RANGECHECKS OFF}
procedure TMain.RB_LSBClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m l -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_USBClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m u -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_AMClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m a -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_DIGClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m d -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_FMClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m f -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_WFMClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m w -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_CWClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m c -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;

procedure TMain.RB_CWRClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -m r -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Mode',error_id);
end;


procedure TMain.LB_CTCSSClick(Sender: TObject);
var c : PChar;
var c2: string;
begin
    c2:=concat('ft100 -c ',LB_CTCSS.Items[LB_CTCSS.ItemIndex],' -D ',ft100_device);
    c:=PChar(c2);
    System_Send_Cmdstring(c,'Error setting CTCSS Tone',error_id);
end;

procedure TMain.LB_DCSClick(Sender: TObject);
var c : PChar;
var c2: string;
begin
    c2:=concat('ft100 -d ',LB_DCS.Items[LB_DCS.ItemIndex],' -D ',ft100_device);
    c:=PChar(c2);
    System_Send_Cmdstring(c,'Error setting DCS Tone',error_id);

end;

procedure TMain.RB_VFO_AClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -v a -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting VFO A',error_id);
end;

procedure TMain.RB_VFO_BClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -v b -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting VFO B',error_id);
end;

procedure TMain.RB_Split_OnxClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -s ON -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Split On',error_id);
end;

procedure TMain.RB_Split_OffxClick(Sender: TObject);
var c : PChar;
begin
    c:=Pchar(concat('ft100 -s OFF -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Split Off',error_id);
end;

procedure TMain.RB_Repeat_SplxClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -r s -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Simplex',error_id);
end;

procedure TMain.RB_Repeat_PlusClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -r p -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Repeater Shift',error_id);
end;

procedure TMain.RB_Repeat_MinusClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -r m -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Repeater Shift',error_id);
end;

procedure TMain.RB_Tone_OffClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t OFF -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting CTCSS/DCS Mode',error_id);
end;

procedure TMain.RB_Tone_ENCClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t ENC -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting CTCSS/DCS Mode',error_id);
end;


procedure TMain.RB_Tone_DECClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t DEC -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting CTCSS/DCS Mode',error_id);
end;

procedure TMain.RB_Tone_DCSClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t dcs -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Tone Mode',error_id);
end;

procedure TMain.btn_Set_FreqClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -f ' ,LCD_Freq.Value,' -D ', ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.btn_QuitClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TMain.btn_Freq_PlusClick(Sender: TObject);
var o_freq : longint ;
var n_freq : longint ;
var step   : longint;
var error_code : integer;
var S: string[11];
var c : PChar;
begin
   Val(LCD_Freq.Value, o_freq, error_code);

   if rb_1K.Checked then
      step:=100
   else
   if rb_5K.Checked then
      step:=500
   else
   if rb_9K.Checked then
      step:=900
   else
   if rb_10K.Checked then
      step:=1000
   else
   if rb_12p5K.Checked then
      step:=1250
   else
   if rb_20K.Checked then
      step:=2000
   else
   if rb_25K.Checked then
      step:=2500
   else
   if rb_50K.Checked then
      step:=5000
   else
   if rb_100K.Checked then
      step:=10000
   else
   if rb_1M.Checked then
      step:=100000
   else
   if rb_10M.Checked then
      step:=1000000
   else
   if rb_Custom.Checked then
      Val(txt_Freq_Step.text, step, error_code)
   else
      step:=0;

   n_freq:=o_freq+step;
   Str(n_freq, S);
   lcd_Freq.Value:=S;
   c:=PChar(concat('ft100 -f ' ,lcd_Freq.Value, ' -D ', ft100_device));
   System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.btn_Freq_MinusClick(Sender: TObject);
var o_freq : longint ;
var n_freq : longint ;
var step   : longint;
var error_code : integer;
var S: string[11];
var c : PChar;
begin
   Val(lcd_Freq.Value, o_freq, error_code);

   if rb_1K.Checked then
      step:=100
   else
   if rb_5K.Checked then
      step:=500
   else
   if rb_9K.Checked then
      step:=900
   else
   if rb_10K.Checked then
      step:=1000
   else
   if rb_12p5K.Checked then
      step:=1250
   else
   if rb_20K.Checked then
      step:=2000
   else
   if rb_25K.Checked then
      step:=2500
   else
   if rb_50K.Checked then
      step:=5000
   else
   if rb_100K.Checked then
      step:=10000
   else
   if rb_1M.Checked then
      step:=100000
   else
   if rb_10M.Checked then
      step:=1000000
   else     
   if rb_Custom.Checked then
      Val(txt_Freq_Step.text, step, error_code)
   else
      step:=0;
      
   n_freq:=o_freq-step;
   Str(n_freq, S);
   lcd_Freq.Value:=S;
   c:=PChar(concat('ft100 -f ' ,lcd_Freq.Value, ' -D ', ft100_device));
   System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.rb_CustomClick(Sender: TObject);
begin
      txt_Freq_Step.Enabled := True;
end;

procedure TMain.rb_1KClick(Sender: TObject);
begin
     txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_5KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_9KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_10KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_12p5KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_20KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_25KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_50KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_100KClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_1MClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.rb_10MClick(Sender: TObject);
begin
txt_Freq_Step.Enabled:=False;
end;

procedure TMain.Timer_UpdateTimerTimer(Sender: TObject);
begin
   UpdateNow(Sender);
   if (error_id > 0) then
        ft100_error_count:=ft100_error_count+1
   else
      ft100_error_count:=0;

   if (ft100_error_count > 1) then
      begin
        Timer_UpdateTimer.enabled:=FALSE;
        cb_Auto_Update.Checked:=FALSE;
        cb_Auto_Update.enabled:=FALSE;
        ShowMessage('Excessive Errors on FT100 Reads, access disabled');
      end;
end;

Procedure TMain.UpdateNow(Sender: TObject);
var c : PChar;
var vswr, vmin, vmax:real;
var vswr_str:string;

var i : integer;
var fd : textfile;
var Band, Filter, OP_Mode, CTCSS, DCS, Flag1, Flag2,
    Clar1, Clar2, Step1a, Step1b, Step2a, Step2b : integer;
var att_on, ipo_on, minus_shift, plus_shift, d1,
    ssb_mode, cw_mode, am_mode, fm_mode,d2,d3, split_mode,
    dcs_on, enc_on, tsq_on, Filter_Data : integer;
var mic_sw1, fwd_tx, rev_tx, s_units, mic_level, sql_level,
    mic_sw2, final_temp, alc_level :integer;
var Freq, fl,fm,fr, s , tone, code : string;

var flag_dummy1, flag_dummy2, flag_dummy3, flag_dummy4, flag_dummy5, flag_dummy6, flag_dummy7: integer;
var flag_tx_in, flag_mute, flag_power, flag_cat_in, flag_tune, flag_split: integer;
var flag_srch, flag_mem, flag_m_tune, flag_qmb, flag_b_vfo, flag_mr_chk:integer;
var flag_upscn, flag_sqlsc, flag_lock, flag_bkmr, flag_tuner, flag_fast : integer;
var flag_pttwa, flag_keyup, flag_notx, flag_cattx, flag_fmloc, flag_10mhz, flag_1mhz:integer;
var flag_prgm, flag_group, flag_alock, flag_dspnr, flag_dspnt, flag_dspbp:integer;
var flag_hi_swr, flag_wait, flag_auxtx, flag_keyer, flag_bkin, flag_arts:integer;
var flag_mtmod, flag_agcfs, flag_agcsl, flag_busy, flag_dulck, flag_dulon:integer;
var flag_vox_on, flag_nbon, flag_proc,  flag_mufst, flag_side: integer;

var error_id: integer;

begin
    c:=PChar(concat('ft100 -D ',ft100_device, ' -g > /dev/null '));
    // c:='ft100 -g >> ft100.tst';
    System_Send_Cmdstring(c,'Error getting rig info',error_id);

    AssignFile(fd,'.ft100_status');
    Reset(fd);
    Readln(fd,Band);
    Readln(fd,Freq);
    Readln(fd,Filter);
    Readln(fd,OP_Mode);
    Readln(fd,CTCSS,tone);
    tone:=Trim(tone);
    Readln(fd,DCS,code);
    code:=Trim(code);
    Readln(fd,Flag1, att_on, ipo_on, minus_shift, plus_shift, d1, dcs_on, tsq_on, enc_on);
    Readln(fd,Flag2,split_mode,d1,d2,d3,fm_mode,am_mode,cw_mode,ssb_mode);
    Readln(fd,Clar1);
    Readln(fd,Clar2);
    Readln(fd,Step1a);
    Readln(fd,Step1b);
    Readln(fd,Step2a);
    Readln(fd,Step2b);
    Readln(fd,Filter_Data);

    // read all of the flags
    Readln(fd, flag_tx_in, flag_mute, flag_power, flag_dummy1, flag_cat_in, flag_tune, flag_dummy2, flag_split);
    Readln(fd, flag_srch, flag_mem, flag_m_tune, flag_qmb, flag_b_vfo, flag_mr_chk, flag_dummy1);
    Readln(fd, flag_srch, flag_mem, flag_upscn, flag_sqlsc, flag_lock, flag_bkmr, flag_tuner, flag_fast);
    Readln(fd, flag_pttwa, flag_keyup, flag_notx, flag_cattx, flag_dummy1, flag_fmloc, flag_10mhz, flag_1mhz);
    Readln(fd, flag_dummy1, flag_prgm, flag_group, flag_alock, flag_dspnr, flag_dspnt, flag_dspbp);
    Readln(fd, flag_hi_swr, flag_wait, flag_dummy1, flag_dummy2, flag_auxtx, flag_keyer, flag_bkin, flag_arts);
    Readln(fd, flag_mtmod, flag_agcfs, flag_agcsl, flag_dummy1, flag_busy, flag_dummy2, flag_dulck, flag_dulon);
    Readln(fd, flag_vox_on, flag_nbon, flag_proc, flag_dummy1, flag_dummy2, flag_dummy3, flag_mufst, flag_side);
    closefile(fd);


    
    AssignFile(fd,'.ft100_meters');
    Reset(fd);
    Readln(fd, mic_sw1);
    Readln(fd, fwd_tx);
    Readln(fd, rev_tx);
    Readln(fd, s_units);
    Readln(fd, mic_level);
    Readln(fd, sql_level);
    Readln(fd, mic_sw2);
    Readln(fd, final_temp);
    Readln(fd, alc_level);
    Closefile(fd);


    pb_fwd_tx.Position:=fwd_tx;
    pb_rev_tx.position:=rev_tx;
    pb_s_units.position:=abs(255-s_units);
    pb_mic_level.position:=mic_level;
    pb_final_temp.position:=final_temp;
    pb_alc_level.position:=alc_level;

    vmin:=fwd_tx-rev_tx;
    vmax:=fwd_tx+rev_tx;
    if vmin = 0 then
       vswr:=0
    else
       vswr:=vmax/vmin;

    vswr_str:=FloatToStrF(vswr,ffFixed,5,3);
    LCD_vswr.value:=vswr_str;
    if flag_split = 1 then
       begin
         cb_Split.Checked := True;
         lbl_split.font.weight:=fwBold;
       end
       else
        begin
          cb_Split.Checked := False;
          lbl_split.font.weight:=fwNormal;
        end;

   if flag_cat_in = 1 then lbl_cat_in.Font.weight :=fwBold
                      else lbl_cat_in.Font.weight :=fwNormal;

   if flag_power = 1 then lbl_power.Font.weight:=fwBold
                     else lbl_power.Font.weight:=fwNormal;

   if flag_mute = 1 then
      begin
         lbl_mute.Font.Weight:=fwBold;
         ScanSigDetect:=FALSE;
      end
   else
      begin
        lbl_mute.Font.Weight:=fwNormal;
        ScanSigDetect:=TRUE;
      end;

   if flag_tx_in = 1 then lbl_tx_in.Font.Weight := fwBold
                     else lbl_tx_in.Font.Weight := fwNormal;

   if flag_srch = 1 then lbl_srch.Font.Weight := fwBold
                    else lbl_srch.Font.Weight := fwNormal;

   if minus_shift = 1 then RB_Repeat_Minus.Checked:=True;
   if plus_shift  = 1 then RB_Repeat_Plus.Checked:=True;
   if minus_shift + plus_shift = 0 then RB_Repeat_SPLX.Checked:=True;

   if dcs_on = 1 then rb_Tone_DCS.Checked := True
                 else rb_Tone_DCS.Checked := False;

   if enc_on = 1 then
      if tsq_on = 1 then rb_Tone_TSQ.Checked := True
                    else rb_Tone_Encode.Checked := True;

    case  filter of
       0: rb_Filter_6K.Checked:=True;
       1: rb_Filter_24K.Checked:=True;
       2: rb_Filter_500.Checked:=True;
       3: rb_Filter_300.Checked:=True;
    end;

    lcd_Freq.Value:=Freq;
    StatusBar.Panels[2].Text:=Freq;
    
    case  OP_Mode of
        0:
           begin
              RB_LSB.Checked:=True;
              StatusBar.Panels[1].Text:='LSB';
           end;
        1:
           begin
             RB_USB.Checked:=True;
             StatusBar.Panels[1].Text:='USB';
           end;
        2:
           begin
             RB_CW.Checked:=True;
             StatusBar.Panels[1].Text:='CW';
           end;
        3:
           begin
             RB_CWR.Checked:=True;
             StatusBar.Panels[1].Text:='CWR';
           end;
        4:
           begin
             RB_AM.Checked:=True;
             StatusBar.Panels[1].Text:='AM';
           end;
        5:
           begin
             RB_DIG.Checked:=True;
             StatusBar.Panels[1].Text:='DIG';
           end;
        6:
           begin
             RB_FM.Checked:=True;
             StatusBar.Panels[1].Text:='FM';
           end;
        7:
           begin
             RB_WFM.Checked:=True;
             StatusBar.Panels[1].Text:='WFM';
           end;
     end;

     // set tone in table
     for i:=1 to LB_CTCSS.Rows-1 do
        begin
           if tone = LB_CTCSS.Items[i] then
              begin
                LB_CTCSS.Selected[i] := True;
              end
        end;

     // set DCS in table;
     for i:=1 to LB_DCS.Rows - 1 do
        begin
           if code = LB_DCS.Items[i] then
              begin
                LB_DCS.Selected[i] := True;
              end
        end;
end;




procedure TMain.btn_kpdownClick(Sender: TObject);
var o_freq : longint ;
var n_freq : longint ;
var step   : longint;
var error_code : integer;
var S: string[11];
var c : PChar;
begin
   Val(lcd_Freq.Value, o_freq, error_code);

   if rb_1K.Checked then
      step:=100
   else
   if rb_5K.Checked then
      step:=500
   else
   if rb_9K.Checked then
      step:=900
   else
   if rb_10K.Checked then
      step:=1000
   else
   if rb_12p5K.Checked then
      step:=1250
   else
   if rb_20K.Checked then
      step:=2000
   else
   if rb_25K.Checked then
      step:=2500
   else
   if rb_50K.Checked then
      step:=5000
   else
   if rb_100K.Checked then
      step:=10000
   else
   if rb_1M.Checked then
      step:=100000
   else
   if rb_10M.Checked then
      step:=1000000
   else
   if rb_Custom.Checked then
      Val(txt_Freq_Step.text, step, error_code)
   else
      step:=0;

   n_freq:=o_freq - step;
   Str(n_freq, S);
   lcd_Freq.Value:=S;
   c:=PChar(concat('ft100 -f ' ,lcd_Freq.Value,' -D ', ft100_device));
   System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.btn_kpupClick(Sender: TObject);
var o_freq : longint ;
var n_freq : longint ;
var step   : longint;
var error_code : integer;
var S: string[11];
var c : PChar;
begin
   Val(lcd_Freq.Value, o_freq, error_code);

   if rb_1K.Checked then
      step:=100
   else
   if rb_5K.Checked then
      step:=500
   else
   if rb_9K.Checked then
      step:=900
   else
   if rb_10K.Checked then
      step:=1000
   else
   if rb_12p5K.Checked then
      step:=1250
   else
   if rb_20K.Checked then
      step:=2000
   else
   if rb_25K.Checked then
      step:=2500
   else
   if rb_50K.Checked then
      step:=5000
   else
   if rb_100K.Checked then
      step:=10000
   else
   if rb_1M.Checked then
      step:=100000
   else
   if rb_10M.Checked then
      step:=1000000
   else
   if rb_Custom.Checked then
      Val(txt_Freq_Step.text, step, error_code)
   else
      step:=0;

   n_freq:=o_freq + step;
   Str(n_freq, S);
   lcd_Freq.Value:=S;
   // lbl_Freq.Caption:=S;

   c:=PChar(concat('ft100 -f ' ,lcd_Freq.Value, ' -D ',ft100_device));
   System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.btn_kpgoClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -f ' ,lcd_SetFreq.Value,' -D ', ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    lcd_Freq.Value:=lcd_SetFreq.Value;    // just in case update is off
    lcd_SetFreq.Value:='';
end;

procedure TMain.cb_Tone_OnClick(Sender: TObject);
var c : PChar;

begin
      if cb_Tone_On.Checked then
         begin
           rb_Tone_Encode.Enabled:=True;
           rb_Tone_TSQ.Enabled:=True;
           rb_Tone_DCS.Enabled:=True;
         end
     else
         begin
           c:=PChar(concat('ft100 -t off -D',ft100_device));
           System_Send_Cmdstring(c,'Error setting Tone Mode',error_id);
           rb_Tone_Encode.Enabled:=False;
           rb_Tone_TSQ.Enabled:=False;
           rb_Tone_DCS.Enabled:=False;
           rb_Tone_Encode.Checked:=False;
           rb_Tone_TSQ.Checked:=False;
           rb_Tone_DCS.Checked:=False;
         end
end;

procedure TMain.rb_Tone_EncodeClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t enc -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Tone Mode',error_id);
end;

procedure TMain.rb_Tone_TSQClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -t tsq -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Tone Mode',error_id);
end;

procedure TMain.rb_filter_24kxClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 2.4 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_filter_6kxClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 6.0 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_Filter_300xClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 300 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_Filter_500xClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 500 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.cb_SplitClick(Sender: TObject);
var c : PChar;
begin
   if cb_Split.Checked then
      begin
        c:=PChar(concat('ft100 -s ON -D ',ft100_device));
        System_Send_Cmdstring(c,'Error setting Split',error_id);
      end
   else
      begin
        c:=PChar(concat('ft100 -s OFF -D ',ft100_device));
        System_Send_Cmdstring(c,'Error setting Split',error_id);
      end;

end;

procedure TMain.FormCreate(Sender: TObject);
begin
  HomeDirectory:=GetEnvironmentVariable('HOME');
  kyFT100IniFile:=TIniFile.Create(concat(HomeDirectory,'/kyft100rc'));
  // kyFT100IniFile.ReadString(section,ident,default)
  btn_Launch1.Caption:=kyFT100IniFile.ReadString('launch','desc1','');
  btn_Launch2.Caption:=kyFT100IniFile.ReadString('launch','desc2','');
  btn_Launch3.Caption:=kyFT100IniFile.ReadString('launch','desc3','');
  btn_Launch4.Caption:=kyFT100IniFile.ReadString('launch','desc4','');
  btn_Launch5.Caption:=kyFT100IniFile.ReadString('launch','desc5','');
  btn_Launch6.Caption:=kyFT100IniFile.ReadString('launch','desc6','');
  btn_Launch7.Caption:=kyFT100IniFile.ReadString('launch','desc7','');
  btn_Launch8.Caption:=kyFT100IniFile.ReadString('launch','desc8','');
  btn_Launch9.Caption:=kyFT100IniFile.ReadString('launch','desc9','');
  btn_Launch10.Caption:=kyFT100IniFile.ReadString('launch','desc10','');
  btn_Launch11.Caption:=kyFT100IniFile.ReadString('launch','desc11','');
  btn_Launch12.Caption:=kyFT100IniFile.ReadString('launch','desc12','');


  if btn_Launch1.Caption = '' then btn_Launch1.Visible:=False;
  if btn_Launch2.Caption = '' then btn_Launch2.Visible:=False;
  if btn_Launch3.Caption = '' then btn_Launch3.Visible:=False;
  if btn_Launch4.Caption = '' then btn_Launch4.Visible:=False;
  if btn_Launch5.Caption = '' then btn_Launch5.Visible:=False;
  if btn_Launch6.Caption = '' then btn_Launch6.Visible:=False;
  if btn_Launch7.Caption = '' then btn_Launch7.Visible:=False;
  if btn_Launch8.Caption = '' then btn_Launch8.Visible:=False;
  if btn_Launch9.Caption = '' then btn_Launch9.Visible:=False;
  if btn_Launch10.Caption = '' then btn_Launch10.Visible:=False;   
  if btn_Launch11.Caption = '' then btn_Launch11.Visible:=False;
  if btn_Launch12.Caption = '' then btn_Launch12.Visible:=False;

  // get default device
  ft100_device:=kyFT100IniFile.ReadString('port','device','/dev/ft100');
  StatusBar.Panels[3].Text:=ft100_device;
  
  cb_Split.Checked:=False;
  Memory_Max_Entries:=2500;
  Timer_UpdateTimer.Enabled:=True;
  cb_Auto_Update.Checked:=True;
  PTT:=False;

  PageControl1.ActivePage:=TabVFO;
  MemUpdated:=False;
  LCD_SetFreq.value:='';
  ft100_error_count:=0;
  
end;

procedure TMain.rb_Filter_24kClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 2.4 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_Filter_6KClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 6.0 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_Filter_300Click(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 300 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.rb_Filter_500Click(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -l 500 -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Filter',error_id);
end;

procedure TMain.btn_Open_MemClick(Sender: TObject);
var file_name : string;
var fd : textfile;
var mem: string;
var desc, cmd: string;
var i,j: integer;
var Message_Not_Shown: Boolean;
begin
   Message_Not_Shown:=True;
   if OpenDialog1.Execute then
      begin

        lb_Memory.Clear;
        edit_Mem_Desc.Text:='';
        edit_Mem_Command.Text:='';
        MemEntries:=0;
        file_name:=OpenDialog1.FileName;
        AssignFile(fd,file_name);
        Label13.Caption:=file_name;
        i:=0;
        Reset(fd);
        Readln(fd,mem);
        while not Eof(fd) do
          begin
            j:=pos(';', mem);
            cmd:=Copy(mem,1, j-1);
            desc:=Copy(mem,j+1,1000);
            lb_Memory.Items.Add(desc);
            //lb_Memory.Items[i]:=desc;
            MemTable[i]:=cmd;
            i:=i+1;
            if i > Memory_Max_Entries then
               begin
                 if Message_Not_Shown then
                    begin
                      ShowMessage('More than 2500 Memory Entries.... Procede at your own risk');
                      Message_Not_Shown:=False;
                    end
               end;
            Readln(fd,mem);
            end;
            MemEntries:=i;
            CurrScan:=0;
            cb_Scan.Checked:=False;
            Timer_Scan.Enabled:=False;
            Closefile(fd);
          end;
end;

procedure TMain.lb_MemoryDblClick(Sender: TObject);
var c : PChar;
var j : integer;
begin
  cb_Scan.Checked:=FALSE;
  cb_ScanVFO.Checked:=FALSE;
  Timer_ScanVFO.Enabled:=FALSE;
  Timer_Scan.Enabled:=FALSE;

  j:= lb_Memory.ItemIndex;
  CurrScan:=j;
  c:=PChar(concat('ft100 ' ,MemTable[j],' -D ',ft100_device));
  System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;

procedure TMain.btn_ClearClick(Sender: TObject);
begin
  lb_Memory.Clear;
  edit_Mem_Desc.Text:='';
  edit_Mem_Command.Text:='';
  MemEntries:=0;
  CurrScan:=0;
  cb_Scan.Checked:=False;
  Timer_Scan.Enabled:=False;
  Label13.Caption:='';
end;

procedure TMain.lb_MemoryClick(Sender: TObject);
var i: integer;

begin
  i:=lb_Memory.ItemIndex;
  edit_Mem_Desc.Text:=lb_Memory.Items[i];
  edit_Mem_Command.Text:=MemTable[i];
end;

procedure TMain.btn_Replace_EntryClick(Sender: TObject);
var i: integer;
begin
  i:=lb_Memory.ItemIndex;
  lb_Memory.Items[i]:=edit_Mem_Desc.Text;
  MemTable[i]:=edit_Mem_Command.Text;
  MemUpdated:=True;
end;

procedure TMain.btn_TestClick(Sender: TObject);
var c : PChar;
begin
  c:=PChar(concat('ft100 ', string(edit_Mem_Command.Text),' -D ',ft100_device));
  System_Send_Cmdstring(c,'Error setting Frequency',error_id);
end;


procedure TMain.btn_AddClick(Sender: TObject);
var i: integer;
begin
 i:=lb_Memory.Rows;

 if i > Memory_Max_Entries then
    begin
       ShowMessage('Not added, would exceed memory capacity of 2500 Entries');
    end
 else
    begin
      //lb_Memory.Items[i]:=edit_Mem_Desc.Text;
      lb_Memory.Items.Add(edit_Mem_Desc.Text);
      MemTable[i]:=edit_Mem_Command.Text;
    end;

end;

procedure TMain.btn_SaveClick(Sender: TObject);
var file_name : string;
var fd : textfile;
var recd, t: string;
var i,j,k: integer;

begin
   if SaveDialog1.Execute then
      begin
         file_name:=SaveDialog1.FileName;
         AssignFile(fd,file_name);
         Label13.Caption:=file_name;
         Rewrite(fd);
         j:=lb_Memory.Rows;
         for i:=0 to j-1 do
           begin
             t:=Concat(MemTable[i],';');
             recd:=Concat(t,lb_Memory.Items[i]);
             k:=Length(recd);
             writeln(fd,recd);
           end;
           CloseFile(fd);

      end;
      MemUpdated:=False;
end;

procedure TMain.btn_Mem_UpClick(Sender: TObject);
var tmp:string;
var i,j: integer;
begin
  i:=lb_Memory.ItemIndex;
  if i > 0 then
     begin
       j:=i-1;
       tmp:=lb_Memory.Items[j];
       lb_Memory.Items[j]:=lb_Memory.Items[i];
       lb_Memory.Items[i]:=tmp;

       tmp:=MemTable[j];
       MemTable[j]:=MemTable[i];
       MemTable[i]:=tmp;
       lb_Memory.Selected[j]:=True;

     end
  else
     begin
       Showmessage('Already at the top');
     end;
end;

procedure TMain.btn_Mem_DnClick(Sender: TObject);
var tmp:string;
var i,j: integer;
begin
  i:=lb_Memory.ItemIndex;
  if i < MemEntries-1 then
     begin
       j:=i+1;
       tmp:=lb_Memory.Items[j];
       lb_Memory.Items[j]:=lb_Memory.Items[i];
       lb_Memory.Items[i]:=tmp;

       tmp:=MemTable[j];
       MemTable[j]:=MemTable[i];
       MemTable[i]:=tmp;
       lb_Memory.Selected[j]:=True;

     end
  else
     begin
       Showmessage('Already at the Bottom');
     end;
end;



procedure TMain.btn_kp_ClrClick(Sender: TObject);
begin
    LCD_SetFreq.Value:='';
end;

procedure TMain.btn_kp0Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'0');
      end;
end;

procedure TMain.btn_kp1Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'1');
      end;
end;

procedure TMain.btn_kp2Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'2');
      end;
end;

procedure TMain.btn_kp3Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'3');
      end;
end;

procedure TMain.btn_kp4Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'4');
      end;
end;

procedure TMain.btn_kp5Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'5');
      end;
end;

procedure TMain.btn_kp6Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'6');
      end;
end;

procedure TMain.btn_kp7Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'7');
      end;
end;

procedure TMain.btn_kp8Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'8');
      end;
end;

procedure TMain.btn_kp9Click(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'9');
      end;
end;

procedure TMain.btn_kp_BkspClick(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Leftstr(LCD_SetFreq.Value,Length(LCD_SetFreq.Value)-1)
      end;
end;

procedure TMain.btn_kp_dotClick(Sender: TObject);
begin
   if Length(LCD_SetFreq.Value) < 10 then
      begin
        LCD_SetFreq.Value:=Concat(LCD_SetFreq.Value,'.');
      end;
end;

procedure TMain.btn_Mem_DeleteClick(Sender: TObject);
var i,j,m,selected: integer;
begin
   selected:=lb_Memory.ItemIndex;
   m:=MemEntries - 2;
   lb_Memory.Items.Delete(selected);
   for i:= selected to MemEntries do
      begin
         j:=i+1;
         MemTable[i]:=MemTable[j];
      end;

end;

procedure TMain.btn_GetClick(Sender: TObject);
var cmd : string;
var c : PChar;
var i : integer;
var fd : textfile;
var Band, Filter, OP_Mode, CTCSS, DCS, Flag1, Flag2,
    Clar1, Clar2, Step1a, Step1b, Step2a, Step2b : integer;
var att_on, ipo_on, minus_shift, plus_shift, d1,
    ssb_mode, cw_mode, am_mode, fm_mode,d2,d3, split_mode,
    dcs_on, enc_on, tsq_on, Filter_Data : integer;
var mic_sw1, fwd_tx, rev_tx, s_units, mic_level, sql_level,
    mic_sw2, final_temp, alc_level :integer;
var Freq, fl,fm,fr, s , tone, code : string;
begin
    c:=PChar(concat('ft100 -D ',ft100_device,' -g > /dev/null '));
    System_Send_Cmdstring(c,'Error getting rig info',error_id);

    AssignFile(fd,'.ft100_status');
    Reset(fd);
    Readln(fd,Band);
    Readln(fd,Freq);
    Readln(fd,Filter);
    Readln(fd,OP_Mode);
    Readln(fd,CTCSS,tone);
    tone:=Trim(tone);
    Readln(fd,DCS,code);
    code:=Trim(code);
    Readln(fd,Flag1, att_on, ipo_on, minus_shift, plus_shift, d1, dcs_on, tsq_on, enc_on);
    Readln(fd,Flag2,split_mode,d1,d2,d3,fm_mode,am_mode,cw_mode,ssb_mode);
    Readln(fd,Clar1);
    Readln(fd,Clar2);
    Readln(fd,Step1a);
    Readln(fd,Step1b);
    Readln(fd,Step2a);
    Readln(fd,Step2b);
    Readln(fd,Filter_Data);
    closefile(fd);

   // freq
   cmd:=Concat('-f ',Freq);

   // mode
   cmd:=Concat(cmd, ' -m ');
   case  OP_Mode of
        0:  cmd:=Concat(cmd, 'LSB ');
        1:  cmd:=Concat(cmd, 'USB ');
        2:  cmd:=Concat(cmd, 'CW ');
        3:  cmd:=Concat(cmd, 'CWR ');
        4:  cmd:=Concat(cmd, 'AM ');
        5:  cmd:=Concat(cmd, 'DIG ');
        6:  cmd:=Concat(cmd, 'FM ');
        7:  cmd:=Concat(cmd, 'WFM ');
     end;

   // ctcss
   cmd:=Concat(cmd, ' -c ');
   cmd:=Concat(cmd,  tone);

   // DCS
   cmd:=Concat(cmd, ' -d ');
   cmd:=Concat(cmd,  code);

   // repeater shift
   if minus_shift = 1 then RB_Repeat_Minus.Checked:=True;
   if plus_shift  = 1 then RB_Repeat_Plus.Checked:=True;
   if minus_shift + plus_shift =  0
      then  cmd:=Concat(cmd, ' -r s ')
      else  if  minus_shift = 1 then  cmd:=Concat(cmd, ' -r m ')
                                else  cmd:=Concat(cmd, ' -r p ');


   edit_Mem_Desc.Text:='New Entry';
   edit_Mem_Command.Text:=cmd;
end;


procedure TMain.cb_Auto_UpdateClick(Sender: TObject);
var i,e:integer;
begin
   if cb_Auto_Update.Checked then
      begin
         Timer_UpdateTimer.Enabled:=True;
         Val(msk_edit_update.Text,i,e);
         if e = 0 then  Timer_UpdateTimer.Interval:=i
                  else
                     begin
                        Timer_UpdateTimer.Interval:=500;
                        msk_edit_update.Text:='500';
                     end
      end
   else
      begin
         Timer_UpdateTimer.Enabled:=False;
      end;
end;

procedure TMain.msk_edit_updateChange(Sender: TObject);
var i,e:integer;
begin
   Val(msk_edit_update.Text,i,e);
   if e = 0 then  Timer_UpdateTimer.Interval:=i
             else
                begin
                   Timer_UpdateTimer.Interval:=500;
                   msk_edit_update.Text:='500';
                end
end;

procedure TMain.btn_TuneClick(Sender: TObject);
var c : PChar;

begin
   c:=PChar(' ');
   if PTT then
      begin
         PTT:=False;
         case old_mode of
           'l' : c:='ft100 -p OFF -m l';
           'u' : c:='ft100 -p OFF -m u';
           'a' : c:='ft100 -p OFF -m a';
           'd' : c:='ft100 -p OFF -m d';
           'f' : c:='ft100 -p OFF -m f';
           'w' : c:='ft100 -p OFF -m w';
           'c' : c:='ft100 -p OFF -m c';
           'r' : c:='ft100 -p OFF -m r';
         end;
         c:=PChar(concat(c,' -D ', ft100_device));
         System_Send_Cmdstring(c, 'ERROR Setting PTT OFF',error_id);
      end
   else
       begin
          PTT:=True;
          if RB_LSB.Checked then old_mode := 'l';
          if RB_USB.Checked then old_mode := 'u';
          if RB_FM.Checked  then old_mode := 'f';
          if RB_WFM.Checked then old_mode := 'w';
          if RB_AM.Checked  then old_mode := 'a';
          if RB_DIG.Checked then old_mode := 'd';
          if RB_CW.Checked  then old_mode := 'c';
          if RB_CWR.Checked then old_mode := 'r';
          c:= PChar(concat('ft100 -m a -p ON -D ',ft100_device));
          System_Send_Cmdstring(c, 'ERROR Setting PTT ON',error_id);
      end;
end;

procedure TMain.Exit1Click(Sender: TObject);
var
btn : TMessageButton;
begin
   btn:=smbNo;
   if MemUpdated then
   begin
      btn:=Application.MessageBox('Replace ?','Memory File Modified',[smbYes, smbNo, smbCancel]);
      if btn = smbYes then
      begin
        btn_SaveClick(Sender)
      end;
   end;
   if btn = smbYes then
      Application.Terminate
   else
     if btn = smbNo then
        Application.Terminate;
end;

procedure TMain.Open1Click(Sender: TObject);
begin
PageControl1.ActivePage:=TabMemory;
btn_Open_MemClick(Sender);
end;

procedure TMain.About1Click(Sender: TObject);
var
btn : TMessageButton;
begin
btn:=Application.MessageBox('kyFT100 by KC2IVL','About kyFT100',[smbOK]);
end;



procedure TMain.Button1Click(Sender: TObject);
begin
  Exit1Click(Sender);
end;


procedure TMain.rb_H160mClick(Sender: TObject);
var c : PChar;
begin
    c:=PChar(concat('ft100 -f 00180000 -m LSB -D ',ft100_device));
    System_Send_Cmdstring(c, 'ERROR Setting PTT',error_id);
        PageControl1.ActivePage:=TTabSheet(TabVFO);
end;


procedure TMain.rb_H80mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00350000 -m LSB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H40mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(concat('ft100 -f 00700000 -m LSB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;
    // avf here
procedure TMain.rb_H30mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01010000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H20mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01400000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H17mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01806800 -m USB -D ', ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H15mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02100000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H12mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02489000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H10mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02567000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H6mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 05000000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H2mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 14400000 -m FM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_H70cmClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 43000000 -m FM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S120mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00230000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S90mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00320000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S60mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00475000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S49mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00595000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S41mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00710000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S31mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00950000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S25mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01165000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S22mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01360000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S19mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01510000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S16mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01755000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_S13mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02145000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;
procedure TMain.rb_S11mClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02567000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_FM_BcastClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 08800000 -m WFM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_AM_BcastClick(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00053000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_wwv5Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00500000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_wwv10Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01000000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_wwv15Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 01500000 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_CHU330Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00333000 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_chu7335Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 00733500 -m USB -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb08Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02705500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb12Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02710500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb13Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02711500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb17Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02716500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb23Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02723500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb01Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02696500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb02Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02697500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb03Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02698500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb04Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02700500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb05Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02701500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb06Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02702500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb07Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02703500  -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb09Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02706500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb10Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02707500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb11Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02708500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb14Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02712500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb15Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02713500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb16Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02715500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb18Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02717500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb19Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02718500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb20Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02720500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb21Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02721500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb22Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02722500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb24Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02724500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb25Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02725500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb26Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02726500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb27Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02727500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb28Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02728500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb29Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02729500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb30Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02730500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb31Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02731500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb32Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02732500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb33Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02733500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb34Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02734500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb35Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02735500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb36Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02736500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb37Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02737500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;
procedure TMain.rb_cb38Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02738500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb39Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02739500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.rb_cb40Click(Sender: TObject);
var c: PChar;
begin
    c:=PChar(Concat('ft100 -f 02740500 -m AM -D ',ft100_device));
    System_Send_Cmdstring(c,'Error setting Frequency',error_id);
    PageControl1.ActivePage:=TTabSheet(TabVFO);
end;

procedure TMain.cb_ScanClick(Sender: TObject);
begin
   if cb_Scan.Checked then
     begin
      Timer_Scan.Enabled:=True;
      Timer_ScanVFO.Enabled:=False;
      cb_ScanVFO.Checked:=False;
     end
   else
      Timer_Scan.Enabled:=False;
end;

procedure TMain.Timer_ScanTimer(Sender: TObject);
var c: PChar;
begin
   if ScanSigDetect then
     begin
       Timer_Scan.Enabled:=FALSE;
       Timer_Pause.Enabled:=TRUE;
       cb_Scan.Checked:=FALSE;
     end
   else
     begin
       if CurrScan < MemEntries then
          CurrScan := CurrScan + 1
       else
          CurrScan := 1;
          
       lb_Memory.Selected[CurrScan-1]:=TRUE;
       lb_MemoryClick(Sender);
       c:=PChar(Concat('ft100 ' ,MemTable[CurrScan-1],' -D ',ft100_device));
       System_Send_Cmdstring(c,'Error setting Frequency',error_id);
     end
end;

procedure TMain.msk_VFOPauseDelayChange(Sender: TObject);
var i,e:integer;
begin
   Val(msk_VFOPauseDelay.Text,i,e);
   if e = 0 then  Timer_VFOPauseDelay.Interval:=i
             else
                begin
                   Timer_VFOPauseDelay.Interval:=5000;
                   msk_VFOPauseDelay.Text:='5000';
                end
end;

procedure TMain.cb_ScanVFOClick(Sender: TObject);
var i,e:integer;
begin
   Val(msk_edit_ScanVFO_delay.Text,i,e);
   if cb_ScanVFO.Checked then
     begin
      Timer_Scan.Enabled:=False;
      Timer_ScanVFO.Enabled:=True;
      Timer_ScanVFO.Interval:=i;
      cb_Scan.Checked:=False;
     end
   else
      Timer_ScanVFO.Enabled:=False;
end;

procedure TMain.Timer_ScanVFOTimer(Sender: TObject);
begin
   if ScanSigDetect then
     begin
       Timer_ScanVFO.Enabled:=FALSE;
       cb_ScanVFO.Checked:=FALSE;
       Timer_VFOPauseDelay.Enabled:=TRUE;
     end
   else
     if rb_ScanVFO_Up.Checked=TRUE then
       begin
         btn_kpupClick(Sender);
       end
     else
       begin
         btn_kpdownClick(Sender);
       end;
end;

procedure TMain.msk_edit_ScanVFO_delayChange(Sender: TObject);
var i,e:integer;
begin
   Val(msk_edit_ScanVFO_delay.Text,i,e);
   if e = 0 then  Timer_ScanVFO.Interval:=i
             else
                begin
                   Timer_ScanVFO.Interval:=500;
                   msk_edit_ScanVFO_delay.Text:='500';
                end
end;
procedure TMain.Timer_PauseTimer(Sender: TObject);
begin
   if ScanSigDetect then
     begin
       Timer_Scan.Enabled:=FALSE;
       Timer_Pause.Enabled:=TRUE;
       cb_Scan.Checked:=FALSE;
     end
    else
     begin
       Timer_Scan.Enabled:=TRUE;
       Timer_Pause.Enabled:=FALSE;
       cb_Scan.Checked:=TRUE;
     end;
end;

procedure TMain.Timer_VFOPauseDelayTimer(Sender: TObject);
begin
   if ScanSigDetect then
     begin
       Timer_ScanVFO.Enabled:=FALSE;
       Timer_VFOPauseDelay.Enabled:=TRUE;
       cb_ScanVFO.Checked:=FALSE;
     end
    else
     begin
       Timer_ScanVFO.Enabled:=TRUE;
       Timer_VFOPauseDelay.Enabled:=FALSE;
       cb_ScanVFO.Checked:=TRUE;
     end;
end;

procedure TMain.btn_MemUpClick(Sender: TObject);
var i,j: integer;
begin
  i:=lb_Memory.ItemIndex;
  j:=i-1;
  if i > 0 then
    begin
      lb_Memory.ItemIndex:=j;
      lb_MemoryClick(Sender);
      lb_MemoryDblClick(Sender);
    end
end;

procedure TMain.btn_MemDownClick(Sender: TObject);
var i,j: integer;
begin
  i:=lb_Memory.ItemIndex;
  j:=i+1;
  if i < MemEntries then
    begin
      lb_Memory.ItemIndex:=j;
      lb_MemoryClick(Sender);
      lb_MemoryDblClick(Sender);
    end
end;



procedure TMain.btn_Launch1Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd1','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch2Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd2','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch3Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd3','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch4Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd4','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch5Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd5','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch6Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd6','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch7Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd7','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch8Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd8','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch9Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd9','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch10Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd10','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch11Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd11','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;

procedure TMain.btn_Launch12Click(Sender: TObject);
var cmd : PChar;
begin
   cmd:=PChar(kyFT100IniFile.ReadString('launch','cmd12','xterm'));
   System_Send_Cmdstring(cmd,'Error executing ???',error_id);
end;


procedure TMain.btn_UpdateNowClick(Sender: TObject);
begin
  UpdateNow(Sender);
end;

procedure TMain.System_Send_Cmdstring(cmdstring:PChar; Err_Msg:string; error_id: integer);
var i :integer;
begin
  // writeln(cmdstring);
  i:= Libc.system(cmdstring);
  if (i <>  0) then
      begin
        error_id:=i;
        ShowMessage(Err_Msg);
      end
end;

end.




